using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Telerik.Web.UI;
using System.Drawing;

public partial class _Default : System.Web.UI.Page
{
    private string[] textBoxColumns = new string[] { "ContactName", "CompanyName" };

    protected void Page_Init(object sender, EventArgs e)
    {
        CreateGrid();
    }

    private void CreateGrid()
    {
        RadGrid grid = new RadGrid();
        grid.ID = "RadGrid1";
        grid.DataSourceID = "SqlDataSource1";
        grid.AllowPaging = true;
        grid.AllowSorting = true;
        grid.AllowFilteringByColumn = true;
        grid.PageSize = 20;
        grid.ColumnCreating += new GridColumnCreatingEventHandler(grid_ColumnCreating);
        grid.DataBound += new EventHandler(grid_DataBound);

        grid.MasterTableView.DataKeyNames = new string[] { "CustomerID" };

        foreach (string columnName in textBoxColumns)
        {
            GridTextBoxColumn column = new GridTextBoxColumn();
            column.UniqueName = "template_" + columnName;
            column.DataField = columnName;
            column.HeaderText = columnName;
            column.SortExpression = columnName;
            grid.MasterTableView.Columns.Add(column);
        }
        PlaceHolder1.Controls.Add(grid);
    }

    private void grid_ColumnCreating(object sender, GridColumnCreatingEventArgs e)
    {
        if (e.ColumnType == typeof(GridTextBoxColumn).Name)
            e.Column = new GridTextBoxColumn();
    }
    protected void grid_DataBound(object sender, EventArgs e)
    {
        RadGrid grid = sender as RadGrid;
        foreach (string columnName in textBoxColumns)
        {
            if (grid.MasterTableView.GetColumn(columnName).Visible)
            {
                grid.MasterTableView.SwapColumns("template_" + columnName, columnName);
                grid.MasterTableView.GetColumn("template_" + columnName).Visible = true;
                grid.MasterTableView.GetColumn(columnName).Visible = false;
            }
        }
    }
}



public class GridTextBoxColumn : GridTemplateColumn
{
    public class TextBoxTemplate : ITemplate
    {
        public GridTextBoxColumn Column = null;
        #region ITemplate Members

        public void InstantiateIn(Control container)
        {
            TextBox box = new TextBox();
            box.ID = this.Column.UniqueName;
            container.Controls.Add(box);

            box.DataBinding += new EventHandler(box_DataBinding);
        }
        #endregion

        void box_DataBinding(object sender, EventArgs e)
        {
            GridDataItem dataItem = (GridDataItem)((Control)sender).NamingContainer;
            TextBox box = sender as TextBox;
            box.Text = DataBinder.Eval(dataItem.DataItem, this.Column.DataField).ToString();
        }
    }

    public GridTextBoxColumn()
    {
        TextBoxTemplate template = new TextBoxTemplate();
        template.Column = this;
        this.ItemTemplate = template;
    }
}

